

    //TANGO packages
    import interfaces.*;
    import messages.*;
    import consts.*;

    //Java packages
    import java.applet.*;
    import java.awt.*;
    import java.util.*;


    public class Test extends AppletBase
    {
      public void init()
      { 
        register();    // Registering to TANGO plug-in

        Button[] but = new Button[8];
        setLayout(new FlowLayout());
        but[0] = new Button("ismaster");add(but[0]);
        but[1] = new Button("mastername");add(but[1]);
        but[2] = new Button("username");add(but[2]);
        but[3] = new Button("hostname");add(but[3]);
        but[4] = new Button("participants");add(but[4]);
        but[5] = new Button("actusers");add(but[5]);
        but[6] = new Button("localapps");add(but[6]);  
        but[7] = new Button("sendtoWS");add(but[7]); 
      }

      // Method which handles TANGO messages 
      public void receive(AppEventMessage m)
      {
        CAppAnswerEventMessage mes =  (CAppAnswerEventMessage) m;

        switch((int) mes.getAnswerType())
        {
          case CAConsts.ISMASTER:if (mes.isMaster()) System.out.println("1. MASTER OF THE SESSION");
                                    else System.out.println("1. SLAVE OF THE SESSION");
                                 break;

          case CAConsts.MASTERNAME:System.out.println("MASTER= "+mes.getMastername());break; 

          case CAConsts.USERNAME:System.out.println("USER= "+mes.getUsername());break;

          case CAConsts.HOSTNAME:System.out.println("HOST= "+mes.getHostname());break;

          case CAConsts.PARTICIPANTS: Vector v = mes.getParticipants();
                                      int i=0;
                                      System.out.println("SESSION PARTICIPANTS:");
                                      while(i<v.size())
                                      {
                                        System.out.println((String) v.elementAt(i));
                                        i++;
                                      } 
                                      break;
                                     
          case CAConsts.ACTIVEUSERS: Vector v = mes.getActiveUsers();
                                     int i=0;
                                     System.out.println("ALL USERS:");
                                     while(i<v.size())
                                     {
                                       System.out.println((String) v.elementAt(i));
                                       i++;
                                     } 
                                     break;
                                    
           
          case CAConsts.LOCALAPPS: Vector v = mes.getLocalApps();
                                   int i=0;
                                   System.out.println("ALL LOCAL APPS:");
                                   while(i<v.size())
                                   {
                                     System.out.println((String) v.elementAt(i));
                                     i++;
                                   } 
                                   break;
                                    
          case CAConsts.DATAPASS:  String appname = mes.getSender();
                                   byte[] data = mes.getData();
                                   String word = new String(data,0);
                                   System.out.println("Message: "+word+" from: "+appname);
                                   break;

        }
      }

      public boolean action(Event evt,Object arg)
      {
        if (evt.target instanceof Button) 
        {
          String str = (String) arg;

          byte[] tab = new byte[1];

          if (str.equals("ismaster")) 
          { 
            tab[0] = CAConsts.ISMASTER ; 
            CAppRequestEventMessage mess = new CAppRequestEventMessage(tab);
            send(mess); //Sending a message to Control Application

          }
          if (str.equals("mastername")) 
          { 
            tab[0] = CAConsts.MASTERNAME ; 
            CAppRequestEventMessage mess = new CAppRequestEventMessage(tab);
            send(mess); //Sending a message to Control Application

          }
          
          if (str.equals("username")) 
          { 
            tab[0] = CAConsts.USERNAME ; 
            CAppRequestEventMessage mess = new CAppRequestEventMessage(tab);
            send(mess); //Sending a message to Control Application

          }
          if (str.equals("hostname")) 
          { 
            tab[0] = CAConsts.HOSTNAME ; 
            CAppRequestEventMessage mess = new CAppRequestEventMessage(tab);
            send(mess); //Sending a message to Control Application

          }
          if (str.equals("participants")) 
          { 
            tab[0] = CAConsts.PARTICIPANTS ; 
             CAppRequestEventMessage mess = new CAppRequestEventMessage(tab);
            send(mess); //Sending a message to Control Application

          }
          if (str.equals("actusers")) 
          { 
            tab[0] = CAConsts.ACTIVEUSERS ; 
            CAppRequestEventMessage mess = new CAppRequestEventMessage(tab);
            send(mess); //Sending a message to Control Application
          }
          if (str.equals("localapps")) 
          { 
            tab[0] = CAConsts.LOCALAPPS ; 
            CAppRequestEventMessage mess = new CAppRequestEventMessage(tab);
            send(mess); //Sending a message to Control Application
          }

          if (str.equals("sendtoWS")) 
          { 
            byte[] data = new byte[3];
            data[0]=0;
            data[1]=1;
            data[2]=2;
            byte[] datapass = CAppRequestEventMessage.prepareData("WebSearch",data); 
          
            CAppRequestEventMessage mess = new CAppRequestEventMessage(datapass);
            send(mess); //Sending a message to Control Application
         
          }    

          return true;
        }
        else return false;
      }
    }




