public class Node
{
  public double x,y,len;
  public Node[] nodes;
  public Data data;

  // graphical info
  public int level;
  public int gx, gy;


  // Node constructor
  // x,y: X and Y coordinates of the lower left corner of the square that
  //      this node object represents
  // len: the initial length of the one side of the square.
  // level: at what level this node is constructed.
  public Node(double x, double y, double len, int level)
  {
    nodes = null;
    data  = null;
    this.x = x;
    this.y = y;
    this.len = len;
    this.level = level;
  }

  // determines whether this point[data] is in the square which this node
  // represents or not.
  public boolean inBox( Data data )
  {
    if( (x < data.x) && (data.x < x+len) &&
        (y < data.y) && (data.y < y+len) ) return true;
    return false;
  }
}
