
import java.awt.Graphics;
public class Tree
{
  double x,y,len;
  Node root;
  int height;

  public Tree()
  {
    this.x = 0;
    this.y = 0;
    this.len = 1;
    this.height = 0;
    this.root = null;
  }

  public Tree(double x, double y, double len)
  {
    this.x = x;
    this.y = y;
    this.len = len;
    this.height = 0;
    this.root = null;
  }

  public void processNode(Node node) 
  {
    // Mehmet writes here!

    if( node.nodes == null && node.data == null)
      {
        // draw square at node.gx and node.gy
      }
    else 
      {
        // draw circle at node.gx and node.gy
      }
  };

public void   setPosition(int x, int y)
  {
    root.gx=x;
    root.gy=y;
  }
  

  // For the first call, traverse is called with the root node.
  // x and y coordinates of the root node are set in advance,
  // i.e.
  //       root.gx = some_x_value;
  //       root.gy = some_y_value;
  //       traverse(root);
  //
  public void traverse(Node node,int px,int py,Graphics g)
  {
    if(node != null) 
      {
        processNode(node);
        if(node.nodes != null)
	  for(int i=0; i<4; i++) 
	    {
	      g.drawRect(3,3,px+20,py+20);
	      
	      // calculate node.nodes[i].gx and node.nodes[i].gy 
	      //from node.gx,node.gy, and node.node.nodes[i].level
	      
	      traverse(node.nodes[i],px,py,g);
	    }
      }
  }
  public void insert(Data data)
  {

    System.out.println( "data.x: " + data.x + "  data.y: " + data.y);
    if( root == null )
      {
        // if there is no root at the first insertion,
        // create the root node with the values x=0.0, y=0.0,
        // the length len=1.0, and the level=0.
        // these values are taken from the tree's x,y,len values.
        root = new Node(x,y,len,0);
        // also save the first data as the root's data.
        root.data = data;
      }
    else // otherwise, tree needs to be expanded.
      {
        Node currnode = root;
        while( !( currnode.nodes == null && currnode.data == null )) 
          {
	    System.out.println( "while1 ");

            while( currnode.nodes != null )
	      {
		System.out.println( "while2 ");
		for(int i=0; i<4; i++)
		  if(currnode.nodes[i].inBox( data ))
		    {
		      currnode = currnode.nodes[i];
		      break;
		    }
	      }
            if(currnode.data != null) 
              {
		currnode.nodes = new Node[4];
                currnode.nodes[0] = 
                  new Node( currnode.x, currnode.y, 
                            currnode.len/2, currnode.level+1);
                currnode.nodes[1] = 
                  new Node( currnode.x, currnode.y+currnode.len/2, 
                            currnode.len/2, currnode.level+1);
                currnode.nodes[2] = 
                  new Node( currnode.x+currnode.len/2, currnode.y, 
                            currnode.len/2, currnode.level+1);
                currnode.nodes[3] = 
                  new Node( currnode.x+currnode.len/2, currnode.y+currnode.len/2
, 
                            currnode.len/2, currnode.level+1);

                for(int i=0; i<4; i++)
                  if(currnode.nodes[i].inBox( currnode.data ))
                     {
                       currnode.nodes[i].data = currnode.data;
                       currnode.data = null;
                       break;
                     }
              } // end if

          } // end while

        currnode.data = data;
	if(height < currnode.level)
	  height = currnode.level;
	
      } // end if-else

  } // end insert
}

